]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blame - make.sh
Capi-Utils entfernt.
[people/pmueller/ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06209efc 20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
06209efc
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
be91126f 27VERSION="2.0t5" # Version number
06209efc
MT
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
8f7b33ea 36IPFVER="full" # Which versions should be compiled? (full|devel)
03ad5f93
MT
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
1b273e8f 85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
df5e82b3
MT
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
1b273e8f 89 exiterror "Not running BASH shell."
df5e82b3
MT
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
1b273e8f
MT
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
15679d9f 111 else
1b273e8f 112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
1b273e8f
MT
123 beautify message FAIL
124 exiterror "Not building as root"
15679d9f 125 else
1b273e8f 126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
1b273e8f
MT
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
15679d9f 144 else
1b273e8f 145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
1b273e8f 164 ln -s $BASEDIR/build/tools /
df5e82b3
MT
165 fi
166 if [ ! -h /tools ]; then
1b273e8f 167 exiterror "Could not create /tools symbolic link."
df5e82b3
MT
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
1179dc27 173 MAKETUNING="-j6"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
9b0ff0a0
MT
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
df5e82b3 291 lfsmake2 gzip
9b0ff0a0
MT
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
44254afd 296 lfsmake2 libaal
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65f8f30f 301 lfsmake2 mtd
65998e0a 302 lfsmake2 net-tools
df5e82b3 303 lfsmake2 patch
df5e82b3 304 lfsmake2 psmisc
44254afd 305 lfsmake2 reiser4progs
df5e82b3
MT
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
90d372c4
MT
310 lfsmake2 texinfo
311 lfsmake2 udev
df5e82b3 312 lfsmake2 util-linux
90d372c4 313 lfsmake2 vim
44254afd 314 lfsmake2 grub
df5e82b3
MT
315}
316
15679d9f 317buildipfire() {
907cd036 318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 319 export LOGFILE
15679d9f
MT
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
a10ae6cc 325 ipfiremake linux-atm
15679d9f
MT
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
3a1019f6 329 ipfiremake linux SMP=1
552b817b 330 ipfiremake ipp2p SMP=1
bb5774c8 331 ipfiremake r8169 SMP=1
dd001658 332 ipfiremake zaptel SMP=1
6230f0da 333 ipfiremake fuse SMP=1
c3e36980 334 ipfiremake linux
552b817b 335 ipfiremake ipp2p
bb5774c8 336 ipfiremake r8169
119f6ad3 337 ipfiremake zaptel
d02350a2 338 ipfiremake fuse
c545beb1 339 ipfiremake pkg-config
ad9d4caf 340 ipfiremake cpio
ee78a5ef
MT
341 ipfiremake klibc
342 ipfiremake mkinitcpio
343 ipfiremake udev KLIBC=1
15679d9f
MT
344 ipfiremake expat
345 ipfiremake gdbm
346 ipfiremake gmp
c8ead4a5 347 ipfiremake pam
15679d9f 348 ipfiremake openssl
eac942d9 349 ipfiremake curl
15679d9f
MT
350 ipfiremake python
351 ipfiremake libnet
ddac6087 352 ipfiremake libjpeg
15679d9f
MT
353 ipfiremake libpng
354 ipfiremake libtiff
fd3e7da0 355 ipfiremake libart
9594506f 356 ipfiremake freetype
15679d9f
MT
357 ipfiremake gd
358 ipfiremake popt
411afd1f 359 ipfiremake pcre
15679d9f
MT
360 ipfiremake slang
361 ipfiremake newt
fd3e7da0 362 ipfiremake libcap
15679d9f 363 ipfiremake pciutils
51f3b7f5 364 ipfiremake usbutils
15679d9f 365 ipfiremake libxml2
c6c9630e 366 ipfiremake libxslt
6b8cff41 367 ipfiremake BerkeleyDB
15679d9f 368 ipfiremake mysql
411afd1f 369 ipfiremake cyrus-sasl
15679d9f
MT
370 ipfiremake openldap
371 ipfiremake apache2
372 ipfiremake php
a10ae6cc 373 ipfiremake apache2 PASS=C
15679d9f
MT
374 ipfiremake arping
375 ipfiremake beep
376 ipfiremake bind
15679d9f
MT
377 ipfiremake cdrtools
378 ipfiremake dnsmasq
379 ipfiremake dosfstools
444973a4 380 ipfiremake squashfstools
72d80898 381 ipfiremake reiserfsprogs
93afd047 382 ipfiremake sysfsutils
d02350a2 383 ipfiremake ntfs-3g
15679d9f
MT
384 ipfiremake ethtool
385 ipfiremake ez-ipupdate
386 ipfiremake fcron
e3670217 387 ipfiremake perl-GD
330345c2 388 ipfiremake GD-Graph
786f2c8a 389 ipfiremake GD-TextUtil
15679d9f
MT
390 ipfiremake gnupg
391 ipfiremake hdparm
7861f575 392 ipfiremake mtools
15679d9f
MT
393 ipfiremake ibod
394 ipfiremake initscripts
406f019f 395 ipfiremake whatmask
15679d9f 396 ipfiremake iptables
490256d5 397 ipfiremake libupnp
552b817b 398 ipfiremake ipp2p IPT=1
81a7e7c8 399 ipfiremake moblock
490256d5 400 ipfiremake linux-igd
15679d9f
MT
401 ipfiremake ipac-ng
402 ipfiremake ipaddr
15679d9f 403 ipfiremake iptstate
fd3e7da0 404 ipfiremake iputils
15679d9f 405 ipfiremake l7-protocols
8bba2965 406 ipfiremake mISDN
93afd047 407 ipfiremake hwdata
72d80898 408 ipfiremake kudzu
15679d9f
MT
409 ipfiremake logrotate
410 ipfiremake logwatch
15679d9f 411 ipfiremake misc-progs
15679d9f 412 ipfiremake nano
15679d9f
MT
413 ipfiremake nasm
414 ipfiremake URI
415 ipfiremake HTML-Tagset
416 ipfiremake HTML-Parser
417 ipfiremake Compress-Zlib
418 ipfiremake Digest
419 ipfiremake Digest-SHA1
420 ipfiremake Digest-HMAC
421 ipfiremake libwww-perl
422 ipfiremake Net-DNS
423 ipfiremake Net-IPv4Addr
424 ipfiremake Net_SSLeay
425 ipfiremake IO-Stringy
426 ipfiremake Unix-Syslog
427 ipfiremake Mail-Tools
428 ipfiremake MIME-Tools
429 ipfiremake Net-Server
430 ipfiremake Convert-TNEF
431 ipfiremake Convert-UUlib
432 ipfiremake Archive-Tar
433 ipfiremake Archive-Zip
434 ipfiremake Text-Tabs+Wrap
435 ipfiremake Locale-Country
93afd047 436 ipfiremake XML-Parser
4b122800
MT
437 ipfiremake MP3-Info
438 ipfiremake MP3-Tag
c5568d64 439 ipfiremake glib
15679d9f
MT
440 ipfiremake GeoIP
441 ipfiremake fwhits
442 ipfiremake noip_updater
443 ipfiremake ntp
15679d9f
MT
444 ipfiremake openssh
445 ipfiremake openswan
446 ipfiremake pptpclient
447 ipfiremake rrdtool
448 ipfiremake setserial
449 ipfiremake setup
450 ipfiremake snort
8a5604bf 451 ipfiremake oinkmaster
15679d9f
MT
452 ipfiremake squid
453 ipfiremake squid-graph
454 ipfiremake squidguard
069ae085 455 ipfiremake calamaris
6f00de0d 456 ipfiremake tcpdump
15679d9f
MT
457 ipfiremake traceroute
458 ipfiremake vlan
459 ipfiremake wireless
460 ipfiremake libsafe
15679d9f 461 ipfiremake pakfire
15679d9f 462 ipfiremake java
15679d9f
MT
463 ipfiremake spandsp
464 ipfiremake lzo
465 ipfiremake openvpn
15679d9f 466 ipfiremake pammysql
15679d9f 467 ipfiremake cups
fccb3371
MT
468 ipfiremake ghostscript
469 ipfiremake foomatic
15679d9f
MT
470 ipfiremake samba
471 ipfiremake sudo
472 ipfiremake mc
473 ipfiremake wget
15679d9f
MT
474 ipfiremake bridge-utils
475 ipfiremake screen
476 ipfiremake hddtemp
477 ipfiremake smartmontools
478 ipfiremake htop
15679d9f 479 ipfiremake postfix
15679d9f
MT
480 ipfiremake fetchmail
481 ipfiremake cyrusimap
482 ipfiremake webcyradm
483 ipfiremake mailx
484 ipfiremake clamav
15679d9f 485 ipfiremake spamassassin
fd3e7da0 486 ipfiremake amavisd
0708852c 487 ipfiremake alsa
15679d9f 488 ipfiremake mpg123
a28fdc01 489 ipfiremake mpfire
6c98857b 490 ipfiremake guardian
15679d9f
MT
491 ipfiremake libmad
492 ipfiremake libogg
493 ipfiremake libvorbis
494 ipfiremake lame
15679d9f 495 ipfiremake sox
a6931e7e
MT
496 ipfiremake libshout
497 ipfiremake icecast
498 ipfiremake ices
0708852c
MT
499 ipfiremake mp3blaster
500 ipfiremake libpri
501 ipfiremake stund
0708852c
MT
502 ipfiremake asterisk
503 ipfiremake backup
15679d9f 504 ipfiremake gnump3d
eac942d9 505 ipfiremake libsigc++
15679d9f
MT
506 ipfiremake applejuice
507 ipfiremake ocaml
508 ipfiremake mldonkey
eac942d9
MT
509 ipfiremake libtorrent
510 ipfiremake rtorrent
06209efc 511 ipfiremake ipfireseeder
15679d9f
MT
512 ipfiremake rsync
513 ipfiremake tcpwrapper
514 ipfiremake portmap
515 ipfiremake nfs
516 ipfiremake nmap
517 ipfiremake mbmon
518 ipfiremake iftop
519 ipfiremake ncftp
520 ipfiremake cftp
521 ipfiremake etherwake
522 ipfiremake ethereal
523 ipfiremake tftp-hpa
06da1292 524 ipfiremake bwm-ng
1a8688ba
MT
525 ipfiremake tripwire
526 ipfiremake sysstat
a08c3a2e 527 ipfiremake vsftpd
51f3b7f5 528 ipfiremake which
186e3d2c 529 ipfiremake lsof
df5e82b3
MT
530}
531
532buildinstaller() {
533 # Run installer scripts one by one
534 LOGFILE="$BASEDIR/log/_build.installer.log"
535 export LOGFILE
0afc6d83 536 ipfiremake syslinux
4dc82852
MT
537 ipfiremake as86
538 ipfiremake mbr
fd0763dc 539 ipfiremake memtest
bc9f0c12
MT
540 installmake linux-libc-header
541 installmake binutils
542 ipfiremake uClibc PASS=1
543 ipfiremake gcc INST=1
544 installmake uClibc PASS=2
545 installmake gcc INST=2
546 installmake uClibc PASS=3
df5e82b3 547 installmake busybox
c66941dd 548 installmake udev
33634aa8
MT
549 installmake slang
550 installmake newt
72d80898 551 installmake gettext
33634aa8
MT
552 installmake kbd
553 installmake popt
33634aa8 554 installmake sysvinit
df5e82b3 555 installmake misc-progs
44254afd
MT
556 installmake libaal
557 installmake reiser4progs
89069053 558 installmake reiserfsprogs
a6316ce4 559 installmake sysfsutils
df5e82b3 560 installmake util-linux
df5e82b3 561 installmake pciutils
c5568d64 562 installmake zlib
65f8f30f 563 installmake mtd
c78a77eb 564 installmake wget
93afd047 565 installmake hwdata
fcb5057d 566 installmake kudzu
df5e82b3 567 installmake installer
df5e82b3 568 installmake initrd
df5e82b3
MT
569}
570
571buildpackages() {
572 LOGFILE="$BASEDIR/log/_build.packages.log"
573 export LOGFILE
574 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 575
edd536b6 576 installmake strip
df5e82b3
MT
577
578 # Generating list of packages used
0fbb45e9 579 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
580 rm -f $BASEDIR/doc/packages-list
581 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
582 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 583 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
584 fi
585 done
7471f6ab 586 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
0fbb45e9 587 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
df5e82b3
MT
588 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
589 rm -f $BASEDIR/doc/packages-list
c9673262 590 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 591 beautify message DONE
df5e82b3 592
9607771a 593 # Create images for install
1cdddb12
MT
594 if [ "$DEVEL" == "1" ]; then
595 ipfiremake cdrom ED=devel
596 fi
74dbbc36
MT
597 ipfiremake cdrom ED=full
598
4dc82852
MT
599 # Check if there is a loop device for building in virtual environments
600 if [ -e /dev/loop0 ]; then
601 ipfiremake usb-stick
602 fi
33634aa8 603 ipfiremake pxe
4dc82852 604 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
c9673262 605
0d909a4a 606 ipfirepackages
e67a57fe
MT
607
608 # Cleanup
609 stdumount
610 rm -rf $BASEDIR/build/tmp/*
611
612 # Generating total list of files
0d909a4a 613 echo -n "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
614 rm -f $BASEDIR/log/FILES
615 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
616 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
617 echo "##" >>$BASEDIR/log/FILES
618 echo "## `basename $i`" >>$BASEDIR/log/FILES
619 echo "##" >>$BASEDIR/log/FILES
620 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
621 fi
622 done
0d909a4a 623 beautify message DONE
e67a57fe
MT
624
625 cd $PWD
e67a57fe
MT
626}
627
628ipfirepackages() {
fe7fe395
MT
629 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
630 [ -e $BASEDIR/lfs/$i ] && ipfiredist $i
631 done
78331e30 632 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 633 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 634 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
635}
636
637# See what we're supposed to do
638case "$1" in
639build)
9729e787 640 clear
df5e82b3 641 BUILDMACHINE=`uname -m`
8f55c54e
MT
642 DEVEL=0
643 if [ "$2" == "--devel" ]; then
644 DEVEL=1
645 fi
712d859c 646 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 647 #only restore on a clean disk
9b0ff0a0 648 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 649 if [ ! -n "$PACKAGE" ]; then
15679d9f 650 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
651 prepareenv
652 buildtoolchain
653 else
654 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 655 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
656 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
657 tar zxf $PACKAGE
658 prepareenv
659 else
660 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
661 fi
662 fi
663 else
9729e787
MT
664 echo -n "Using installed toolchain" | tee -a $LOGFILE
665 beautify message SKIP
df5e82b3
MT
666 prepareenv
667 fi
5cfe86e6 668
7ab7a9b4 669 beautify build_start
0b59f25c 670 beautify build_stage "Building LFS"
df5e82b3 671 buildbase
15679d9f 672
0b59f25c 673 beautify build_stage "Building IPFire"
15679d9f 674 buildipfire
5cfe86e6
HS
675
676 # Setzen des IPFire Builds
8af06406 677 if [ "$FIREBUILD" ]; then
e57bc1fd 678 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 679 else
e57bc1fd 680 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
681 fi
682
0b59f25c 683 beautify build_stage "Building installer"
df5e82b3 684 buildinstaller
15679d9f 685
0b59f25c 686 beautify build_stage "Building packages"
df5e82b3 687 buildpackages
7ab7a9b4 688 beautify build_end
df5e82b3
MT
689 ;;
690shell)
691 # enter a shell inside LFS chroot
692 # may be used to changed kernel settings
693 prepareenv
694 entershell
695 ;;
696changelog)
d1dd6669 697 echo -n "Loading new Changelog from SVN: "
223ad6a4 698 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
a50d04ab 699 beautify message DONE
df5e82b3 700 ;;
df5e82b3 701clean)
a50d04ab 702 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
703 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
704 $LOSETUP -d $i 2>/dev/null
705 done
706 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
707 umount $i
708 done
709 stdumount
710 for i in `seq 0 7`; do
711 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
712 umount /dev/loop${i} 2>/dev/null;
713 losetup -d /dev/loop${i} 2>/dev/null;
714 fi;
715 done
716 rm -rf $BASEDIR/build
717 rm -rf $BASEDIR/cdrom
f9315063 718 rm -rf $BASEDIR/packages
df5e82b3 719 rm -rf $BASEDIR/log
df5e82b3
MT
720 if [ -h /tools ]; then
721 rm -f /tools
722 fi
a50d04ab 723 beautify message DONE
df5e82b3 724 ;;
c3db995c 725downloadsrc)
df5e82b3
MT
726 if [ ! -d $BASEDIR/cache ]; then
727 mkdir $BASEDIR/cache
728 fi
729 mkdir -p $BASEDIR/log
857d9bf2 730 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
731 FINISHED=0
732 cd $BASEDIR/lfs
733 for c in `seq $MAX_RETRIES`; do
734 if (( FINISHED==1 )); then
735 break
736 fi
737 FINISHED=1
738 cd $BASEDIR/lfs
739 for i in *; do
740 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 741 echo -ne "Loading $i"
df5e82b3
MT
742 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
743 if [ $? -ne 0 ]; then
e22c7973 744 beautify message FAIL
df5e82b3
MT
745 FINISHED=0
746 else
747 if [ $c -eq 1 ]; then
e22c7973 748 beautify message DONE
df5e82b3
MT
749 fi
750 fi
751 fi
752 done
753 done
e22c7973 754 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
755 ERROR=0
756 for i in *; do
757 if [ -f "$i" -a "$i" != "Config" ]; then
758 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
759 if [ $? -ne 0 ]; then
e22c7973
MT
760 echo -ne "MD5 difference in lfs/$i"
761 beautify message FAIL
df5e82b3
MT
762 ERROR=1
763 fi
764 fi
765 done
766 if [ $ERROR -eq 0 ]; then
e22c7973
MT
767 echo -ne "${BOLD}all files md5sum match${NORMAL}"
768 beautify message DONE
769 else
770 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
771 beautify message FAIL
df5e82b3 772 fi
e22c7973 773 cd - >/dev/null 2>&1
df5e82b3 774 ;;
df5e82b3 775toolchain)
9729e787 776 clear
df5e82b3 777 prepareenv
15679d9f 778 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
779 buildtoolchain
780 BUILDMACHINE=`uname -m`
781 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
782 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
783 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
784 build/{bin,etc,usr/bin,usr/local} \
785 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
786 log >> $LOGFILE
712d859c
MT
787 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
788 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
789 stdumount
790 ;;
791gettoolchain)
792 BUILDMACHINE=`uname -m`
793 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 794 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 795 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 796 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
797 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
798 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
799 cd $BASEDIR/cache/toolchains
5bd13f01 800 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
801 if [ $? -ne 0 ]; then
802 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 803 else
712d859c
MT
804 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
805 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
806 else
807 exiterror "$PACKAGE.md5 did not match, check downloaded package"
808 fi
40a4ea4c 809 fi
712d859c
MT
810 else
811 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
812 fi
813 ;;
15679d9f 814othersrc)
ce56e927 815 prepareenv
15679d9f 816 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
817 chroot $LFS /tools/bin/env -i HOME=/root \
818 TERM=$TERM PS1='\u:\w\$ ' \
819 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
820 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
821 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
822 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
823 if [ $? -eq "0" ]; then
824 beautify message DONE
825 else
826 beautify message FAIL
827 fi
ce56e927
MT
828 stdumount
829 ;;
c6cb9d25
MT
830svn)
831 case "$2" in
832 update|up)
cc0e56be 833 # clear
15679d9f 834 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
835 if [ $3 ]; then
836 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
837 else
838 svn update | tee -a $PWD/log/_build.svn.update.log
839 fi
15679d9f
MT
840 if [ $? -eq "0" ]; then
841 beautify message DONE
c6cb9d25 842 else
15679d9f 843 beautify message FAIL
c6cb9d25
MT
844 exit 1
845 fi
15679d9f 846 echo -ne "Writing the svn-info to a file"
c6cb9d25 847 svn info > $PWD/svn_status
15679d9f
MT
848 if [ $? -eq "0" ]; then
849 beautify message DONE
c6cb9d25 850 else
15679d9f 851 beautify message FAIL
c6cb9d25
MT
852 exit 1
853 fi
712d859c 854 chmod 755 $0
cc0e56be 855 exit 0
c6cb9d25
MT
856 ;;
857 commit|ci)
858 clear
6b8cff41
MT
859 if [ -f /usr/bin/mcedit ]; then
860 export EDITOR=/usr/bin/mcedit
73d9a908
MT
861 fi
862 if [ -f /usr/bin/nano ]; then
863 export EDITOR=/usr/bin/nano
6b8cff41
MT
864 fi
865 echo -ne "Selecting editor $EDITOR..."
866 beautify message DONE
d79b46cb 867 if [ -e /sbin/yast ]; then
028698e8
MT
868 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
869 $0 changelog
870 fi
d79b46cb 871 fi
8a5f0f44 872 update_langs
15679d9f 873 svn commit
c6cb9d25 874 $0 svn up
1065bfea
MT
875 if [ -n "$FTP_CACHE_URL" ]; then
876 $0 uploadsrc
877 fi
c6cb9d25
MT
878 ;;
879 dist)
7471f6ab
MT
880 if [ $3 ]; then
881 SVN_REVISION=$3
882 fi
883 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
884 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
885 exit 0
886 fi
887 echo -en "REV $SVN_REVISION: Downloading..."
223ad6a4
MT
888 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
889 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
890 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
891 evaluate 1
892
7471f6ab
MT
893 echo -en "REV $SVN_REVISION: Compressing files..."
894 if [ -e ipfire-source/trunk/make.sh ]; then
895 chmod 755 ipfire-source/trunk/make.sh
896 fi
9dc02b38 897 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 898 evaluate 1
7471f6ab 899 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 900 rm ipfire-source/ -r
15679d9f 901 evaluate 1
7471f6ab 902 ;;
028698e8 903 diff|di)
1a8688ba 904 update_langs
15679d9f 905 echo -ne "Make a local diff to last svn revision"
c6cb9d25 906 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 907 evaluate 1
c6cb9d25 908 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
bf7c473f 909 svn status
c6cb9d25
MT
910 ;;
911 esac
f9315063 912 ;;
15679d9f
MT
913uploadsrc)
914 PWD=`pwd`
915 cd $BASEDIR/cache/
916 echo -e "Uploading cache to ftp server:"
6fb8ec08 917 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
15679d9f 918 for i in *; do
f59e1e88 919 if [ "$i" == "toolchains" ]; then continue; fi
6fb8ec08 920 grep -q $i /tmp/ftplist
0eab8e84 921 if [ "$?" -ne "0" ]; then
15679d9f 922 echo -ne "$i"
71e32384 923 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
6fb8ec08 924 if [ "$?" -ne "0" ]; then
15679d9f 925 beautify message FAIL
0eab8e84
MT
926 fi
927 fi
928 done
6fb8ec08 929 rm -f /tmp/ftplist
15679d9f
MT
930 cd $PWD
931 exit 0
0eab8e84 932 ;;
cc0e56be 933upload)
b2c64f8c
MT
934 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
935 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
936 if [ -z $FTP_ISO_PORT ]; then
937 FTP_ISO_PORT=21
938 fi
939 cat <<EOF > .ftp-commands
de2c999d 940mkdir -p $FTP_ISO_PATH$SVN_REVISION
b2c64f8c 941mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
9dc02b38
MT
942quit
943EOF
b2c64f8c
MT
944 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
945 rm -f .ftp-commands
946
947 case "$2" in
948 iso)
949 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
950
8f55c54e 951 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
dff9df9d
MT
952 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
953 if [ -e "$i" ]; then
b2c64f8c
MT
954 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
955 if [ "$?" -eq "0" ]; then
956 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
957 else
958 echo "There was an error while uploading the file $i to the ftp server."
959 exit 1
960 fi
dff9df9d 961 fi
b2c64f8c 962 done
a4c9c660 963 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
6aae8d61 964 if [ "$3" = "--with-sources-cd" ]; then
b2c64f8c 965 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 966 fi
cc0e56be
MT
967 ;;
968 paks)
b2c64f8c 969 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
cc0e56be 970 if [ "$?" -eq "0" ]; then
822c5bd0 971 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
cc0e56be
MT
972 else
973 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 974 exit 1
cc0e56be
MT
975 fi
976 ;;
977 esac
0d0521b6 978 ;;
cc0e56be 979batch)
c8582074 980 if [ "$2" = "--background" ]; then
15679d9f
MT
981 batch_script
982 exit $?
983 fi
27ac55bf 984 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
985 echo "Build is already running, sorry!"
986 exit 1
987 else
27ac55bf
MT
988 if [ "$2" = "--rebuild" ]; then
989 export IPFIRE_REBUILD=1
990 echo "REBUILD!"
991 else
992 export IPFIRE_REBUILD=0
993 fi
15679d9f
MT
994 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
995 screen -dmS ipfire $0 batch --background
996 evaluate 1
712d859c
MT
997 exit 0
998 fi
cc0e56be 999 ;;
028698e8 1000watch)
15679d9f 1001 watch_screen
028698e8 1002 ;;
33634aa8
MT
1003pxe)
1004 case "$2" in
1005 start)
1006 start_tftpd
1007 ;;
1008 stop)
1009 stop_tftpd
1010 ;;
a50d04ab 1011 reload|restart)
33634aa8
MT
1012 reload_tftpd
1013 ;;
1014 esac
1015 exit 0
1016 ;;
bf7c473f
MT
1017lang)
1018 update_langs
1019 ;;
0d909a4a
MT
1020packages)
1021 case "$2" in
1022 sign)
1023 sign_packages
1024 ;;
1025 esac
1026 ;;
6b8cff41 1027"")
24a4a744
MT
1028 clear
1029 svn info
c3db995c 1030 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1031 do
1032 case $name in
c3db995c
MT
1033 "IPFIRE: Downloadsrc")
1034 $0 downloadsrc
c6cb9d25
MT
1035 ;;
1036 "IPFIRE: Build (silent)")
1037 $0 build-silent
1038 ;;
1039 "IPFIRE: Watch Build")
028698e8 1040 $0 watch
c6cb9d25 1041 ;;
712d859c
MT
1042 "IPFIRE: Batch")
1043 $0 batch
1044 ;;
c6cb9d25
MT
1045 "IPFIRE: Clean")
1046 $0 clean
1047 ;;
c6cb9d25
MT
1048 "SVN: Update")
1049 $0 svn update
1050 ;;
c6cb9d25 1051 "Help")
a50d04ab 1052 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1053 cat doc/make.sh-usage
1054 ;;
712d859c
MT
1055 "LOG: Tail")
1056 tail -f log/_*
1057 ;;
c6cb9d25
MT
1058 "Exit")
1059 break
1060 ;;
24a4a744
MT
1061 esac
1062 done
df5e82b3 1063 ;;
a50d04ab
MT
1064config)
1065 make_config
1066 ;;
6b8cff41 1067*)
a50d04ab 1068 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1069 cat doc/make.sh-usage
1070 ;;
3ea75603 1071esac